## sg3-utils 0.95

=== Makefile ===
SHELL = /bin/sh

PREFIX=/usr/local
INSTDIR=$(DESTDIR)/$(PREFIX)/bin
MANDIR=$(DESTDIR)/$(PREFIX)/man

CC = gcc
LD = gcc

EXECS = sg_simple1 sg_simple2 sg_simple3 sg_dd sg_debug \
	sg_scan scsi_inquiry sg_rbuf sginfo sg_readcap \
	sgp_dd sg_map sg_turs isosize sg_inq sg_test_rwbuf \
	scsi_devfs_scan sg_start

COMMON = sg_scan scsi_inquiry sginfo sg_readcap isosize sg_start

MAN_PGS = sg_dd.8 sgp_dd.8 sg_map.8 sg_rbuf.8 isosize.8
MAN_PREF = man8

CFLAGS = -g -O2 -Wall -D_REENTRANT
# CFLAGS = -g -O2 -Wall -D_REENTRANT -DSG_KERNEL_INCLUDES
# CFLAGS = -g -O2 -Wall -pedantic -D_REENTRANT

LDFLAGS =

all: $(EXECS)

common: $(COMMON)

depend dep:
	for i in *.c; do $(CC) $(INCLUDES) $(CFLAGS) -M $$i; \
	done > .depend

clean:
	/bin/rm -f *.o $(EXECS) core .depend

sg_simple1: sg_simple1.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_simple2: sg_simple2.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_simple3: sg_simple3.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_dd: sg_dd.o sg_err.o llseek.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_debug: sg_debug.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_scan: sg_scan.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^ 

scsi_inquiry: scsi_inquiry.o
	$(LD) -o $@ $(LDFLAGS) $^ 

sginfo: sginfo.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_start: sg_start.o
	$(LD) -o $@ $(LDFLAGS) $^ 

sg_rbuf: sg_rbuf.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_readcap: sg_readcap.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sgp_dd: sgp_dd.o sg_err.o llseek.o
	$(LD) -o $@ $(LDFLAGS) $^ -lpthread

sg_map: sg_map.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_turs: sg_turs.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_test_rwbuf: sg_test_rwbuf.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

isosize: isosize.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_inq: sg_inq.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

scsi_devfs_scan: scsi_devfs_scan.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

install: $(EXECS) $(COMMON)
	install -d $(INSTDIR)
	for name in $^; \
	 do install -s -o root -g root -m 755 $$name $(INSTDIR); \
	done
	for mp in $(MAN_PGS); \
	 do install -o root -g root -m 644 $$mp $(MANDIR)/$(MAN_PREF); \
	 gzip -9f $(MANDIR)/$(MAN_PREF)/$$mp; \
	done

uninstall:
	dists="$(EXECS)"; \
	for name in $$dists; do \
	 rm -f $(INSTDIR)/$$name; \
	done
	for mp in $(MAN_PGS); do \
	 rm -f $(MANDIR)/$(MAN_PREF)/$$mp.gz; \
	done

ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== archive/Makefile ===
SHELL = /bin/sh

INSTDIR=/usr/local/bin
MANDIR=/usr/local/man

CC = gcc
LD = gcc

EXECS = sgq_dd sg_poll sg_reset sg_bus_xfer sg_hold

COMMON = 

MAN_PGS = 
MAN_PREF = man8

CFLAGS = -g -O2 -Wall -D_REENTRANT
# CFLAGS = -g -O2 -Wall -pedantic -D_REENTRANT

LDFLAGS =

all: $(EXECS)

common: $(COMMON)

depend dep:
	for i in *.c; do $(CC) $(INCLUDES) $(CFLAGS) -M $$i; \
	done > .depend

clean:
	/bin/rm -f *.o $(EXECS) core .depend

sg_poll: sg_poll.o ../sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sgq_dd: sgq_dd.o ../sg_err.o ../llseek.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_reset: sg_reset.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_bus_xfer: sg_bus_xfer.o ../sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_hold: sg_hold.o
	$(LD) -o $@ $(LDFLAGS) $^

install: $(EXECS) $(COMMON)
	install -d $(INSTDIR)
	for name in $^; \
	 do install -s -o root -g root -m 755 $$name $(INSTDIR); \
	done
	for mp in $(MAN_PGS); \
	 do install -o root -g root -m 644 $$mp $(MANDIR)/$(MAN_PREF); \
	 gzip -9f $(MANDIR)/$(MAN_PREF)/$$mp; \
	done

uninstall:
	dists="$(EXECS)"; \
	for name in $$dists; do \
	 rm -f $(INSTDIR)/$$name; \
	done
	for mp in $(MAN_PGS); do \
	 rm -f $(MANDIR)/$(MAN_PREF)/$$mp.gz; \
	done

ifeq (.depend,$(wildcard .depend))
include .depend
endif

## sg3-utils 1.05

=== Makefile ===
SHELL = /bin/sh

PREFIX=/usr
INSTDIR=$(DESTDIR)/$(PREFIX)/bin
MANDIR=$(DESTDIR)/$(PREFIX)/man

CC = gcc
LD = gcc

EXECS = sg_dd sgp_dd sgm_dd sg_read sg_map sg_scan sg_rbuf \
	sginfo sg_readcap sg_turs sg_inq sg_test_rwbuf \
	scsi_devfs_scan sg_start sg_reset sg_modes sg_logs \
	sg_senddiag

MAN_PGS = sg_dd.8 sgp_dd.8 sgm_dd.8 sg_read.8 sg_map.8 sg_scan.8 sg_rbuf.8 \
	sginfo.8 sg_readcap.8 sg_turs.8 sg_inq.8 sg_test_rwbuf.8 \
	scsi_devfs_scan.8 sg_start.8 sg_reset.8 sg_modes.8 sg_logs.8 \
	sg_senddiag.8
MAN_PREF = man8

LARGE_FILE_FLAGS = -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64

CFLAGS = -g -O2 -Wall -D_REENTRANT $(LARGE_FILE_FLAGS)
# CFLAGS = -g -O2 -Wall -D_REENTRANT -DSG_KERNEL_INCLUDES $(LARGE_FILE_FLAGS)
# CFLAGS = -g -O2 -Wall -pedantic -D_REENTRANT $(LARGE_FILE_FLAGS)

LDFLAGS =

all: $(EXECS)

depend dep:
	for i in *.c; do $(CC) $(INCLUDES) $(CFLAGS) -M $$i; \
	done > .depend

clean:
	/bin/rm -f *.o $(EXECS) core .depend

sg_dd: sg_dd.o sg_err.o llseek.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_scan: sg_scan.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^ 

sginfo: sginfo.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_start: sg_start.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^ 

sg_rbuf: sg_rbuf.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_readcap: sg_readcap.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sgp_dd: sgp_dd.o sg_err.o llseek.o
	$(LD) -o $@ $(LDFLAGS) $^ -lpthread

sgm_dd: sgm_dd.o sg_err.o llseek.o
	$(LD) -o $@ $(LDFLAGS) $^ -lpthread

sg_map: sg_map.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_turs: sg_turs.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_test_rwbuf: sg_test_rwbuf.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_inq: sg_inq.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

scsi_devfs_scan: scsi_devfs_scan.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_read: sg_read.o sg_err.o llseek.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_reset: sg_reset.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_modes: sg_modes.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_logs: sg_logs.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_senddiag: sg_senddiag.o sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

install: $(EXECS)
	install -d $(INSTDIR)
	for name in $^; \
	 do install -s -o root -g root -m 755 $$name $(INSTDIR); \
	done
	install -d $(MANDIR)/$(MAN_PREF)
	for mp in $(MAN_PGS); \
	 do install -o root -g root -m 644 $$mp $(MANDIR)/$(MAN_PREF); \
	 gzip -9f $(MANDIR)/$(MAN_PREF)/$$mp; \
	done

uninstall:
	dists="$(EXECS)"; \
	for name in $$dists; do \
	 rm -f $(INSTDIR)/$$name; \
	done
	for mp in $(MAN_PGS); do \
	 rm -f $(MANDIR)/$(MAN_PREF)/$$mp.gz; \
	done

ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== archive/Makefile ===
--- 
+++ 
@@ -6,11 +6,11 @@
 CC = gcc
 LD = gcc
 
-EXECS = sgq_dd sg_poll sg_reset sg_bus_xfer sg_hold
+EXECS = sgq_dd sg_poll sg_bus_xfer sg_hold sg_debug isosize
 
-COMMON = 
+COMMON = isosize
 
-MAN_PGS = 
+MAN_PGS = isosize.8
 MAN_PREF = man8
 
 CFLAGS = -g -O2 -Wall -D_REENTRANT
@@ -35,13 +35,16 @@
 sgq_dd: sgq_dd.o ../sg_err.o ../llseek.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-sg_reset: sg_reset.o
-	$(LD) -o $@ $(LDFLAGS) $^
-
 sg_bus_xfer: sg_bus_xfer.o ../sg_err.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 sg_hold: sg_hold.o
+	$(LD) -o $@ $(LDFLAGS) $^
+
+isosize: isosize.o
+	$(LD) -o $@ $(LDFLAGS) $^
+
+sg_debug: sg_debug.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 install: $(EXECS) $(COMMON)

=== examples/Makefile ===
SHELL = /bin/sh

PREFIX=/usr/local
INSTDIR=$(DESTDIR)/$(PREFIX)/bin
MANDIR=$(DESTDIR)/$(PREFIX)/man

CC = gcc
LD = gcc

EXECS = sg_simple1 sg_simple2 sg_simple3 sg_simple4 sg_simple16 \
	sg_simple_aio sg_iovec_tst scsi_inquiry

MAN_PGS = 
MAN_PREF = man8

LARGE_FILE_FLAGS = -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64

CFLAGS = -g -O2 -Wall -D_REENTRANT $(LARGE_FILE_FLAGS)
# CFLAGS = -g -O2 -Wall -D_REENTRANT -DSG_KERNEL_INCLUDES $(LARGE_FILE_FLAGS)
# CFLAGS = -g -O2 -Wall -pedantic -D_REENTRANT $(LARGE_FILE_FLAGS)

LDFLAGS =

all: $(EXECS)

depend dep:
	for i in *.c; do $(CC) $(INCLUDES) $(CFLAGS) -M $$i; \
	done > .depend

clean:
	/bin/rm -f *.o $(EXECS) core .depend

sg_simple1: sg_simple1.o ../sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_simple2: sg_simple2.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_simple3: sg_simple3.o ../sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_simple4: sg_simple4.o ../sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_simple16: sg_simple16.o ../sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

sg_simple_aio: sg_simple_aio.o ../sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^ -l aio

sg_iovec_tst: sg_iovec_tst.o ../sg_err.o
	$(LD) -o $@ $(LDFLAGS) $^

scsi_inquiry: scsi_inquiry.o
	$(LD) -o $@ $(LDFLAGS) $^ 

install: $(EXECS)
	install -d $(INSTDIR)
	for name in $^; \
	 do install -s -o root -g root -m 755 $$name $(INSTDIR); \
	done
	install -d $(MANDIR)/$(MAN_PREF)
	for mp in $(MAN_PGS); \
	 do install -o root -g root -m 644 $$mp $(MANDIR)/$(MAN_PREF); \
	 gzip -9f $(MANDIR)/$(MAN_PREF)/$$mp; \
	done

uninstall:
	dists="$(EXECS)"; \
	for name in $$dists; do \
	 rm -f $(INSTDIR)/$$name; \
	done
	for mp in $(MAN_PGS); do \
	 rm -f $(MANDIR)/$(MAN_PREF)/$$mp.gz; \
	done

ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== utils/Makefile ===
SHELL = /bin/sh

PREFIX=/usr/local
INSTDIR=$(DESTDIR)/$(PREFIX)/bin
MANDIR=$(DESTDIR)/$(PREFIX)/man

CC = gcc
LD = gcc

EXECS = hxascdmp

MAN_PGS = 
MAN_PREF = man8

LARGE_FILE_FLAGS = -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64

CFLAGS = -g -O2 -Wall -D_REENTRANT $(LARGE_FILE_FLAGS)
# CFLAGS = -g -O2 -Wall -D_REENTRANT -DSG_KERNEL_INCLUDES $(LARGE_FILE_FLAGS)
# CFLAGS = -g -O2 -Wall -pedantic -D_REENTRANT $(LARGE_FILE_FLAGS)

LDFLAGS =

all: $(EXECS)

depend dep:
	for i in *.c; do $(CC) $(INCLUDES) $(CFLAGS) -M $$i; \
	done > .depend

clean:
	/bin/rm -f *.o $(EXECS) core .depend

hxascdmp: hxascdmp.o
	$(LD) -o $@ $(LDFLAGS) $^


install: $(EXECS)
	install -d $(INSTDIR)
	for name in $^; \
	 do install -s -o root -g root -m 755 $$name $(INSTDIR); \
	done
	install -d $(MANDIR)/$(MAN_PREF)
	for mp in $(MAN_PGS); \
	 do install -o root -g root -m 644 $$mp $(MANDIR)/$(MAN_PREF); \
	 gzip -9f $(MANDIR)/$(MAN_PREF)/$$mp; \
	done

uninstall:
	dists="$(EXECS)"; \
	for name in $$dists; do \
	 rm -f $(INSTDIR)/$$name; \
	done
	for mp in $(MAN_PGS); do \
	 rm -f $(MANDIR)/$(MAN_PREF)/$$mp.gz; \
	done

ifeq (.depend,$(wildcard .depend))
include .depend
endif

## sg3-utils 1.08

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 SHELL = /bin/sh
 
-PREFIX=/usr
+PREFIX=/usr/local
 INSTDIR=$(DESTDIR)/$(PREFIX)/bin
 MANDIR=$(DESTDIR)/$(PREFIX)/man
 
@@ -9,20 +9,20 @@
 
 EXECS = sg_dd sgp_dd sgm_dd sg_read sg_map sg_scan sg_rbuf \
 	sginfo sg_readcap sg_turs sg_inq sg_test_rwbuf \
-	scsi_devfs_scan sg_start sg_reset sg_modes sg_logs \
-	sg_senddiag
+	sg_start sg_reset sg_modes sg_logs sg_senddiag sg_opcodes \
+	sg_persist sg_write_long sg_read_long
 
 MAN_PGS = sg_dd.8 sgp_dd.8 sgm_dd.8 sg_read.8 sg_map.8 sg_scan.8 sg_rbuf.8 \
 	sginfo.8 sg_readcap.8 sg_turs.8 sg_inq.8 sg_test_rwbuf.8 \
-	scsi_devfs_scan.8 sg_start.8 sg_reset.8 sg_modes.8 sg_logs.8 \
-	sg_senddiag.8
+	sg_start.8 sg_reset.8 sg_modes.8 sg_logs.8 sg_senddiag.8 \
+	sg_opcodes.8 sg_persist.8 sg_write_long.8 sg_read_long.8
 MAN_PREF = man8
 
 LARGE_FILE_FLAGS = -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
 
-CFLAGS = -g -O2 -Wall -D_REENTRANT $(LARGE_FILE_FLAGS)
-# CFLAGS = -g -O2 -Wall -D_REENTRANT -DSG_KERNEL_INCLUDES $(LARGE_FILE_FLAGS)
-# CFLAGS = -g -O2 -Wall -pedantic -D_REENTRANT $(LARGE_FILE_FLAGS)
+CFLAGS = -g -O2 -Wall -W -D_REENTRANT $(LARGE_FILE_FLAGS)
+# CFLAGS = -g -O2 -W -D_REENTRANT -DSG_KERNEL_INCLUDES $(LARGE_FILE_FLAGS)
+# CFLAGS = -g -O2 -Wall -pedantic -std=c99 -D_REENTRANT $(LARGE_FILE_FLAGS)
 
 LDFLAGS =
 
@@ -33,7 +33,7 @@
 	done > .depend
 
 clean:
-	/bin/rm -f *.o $(EXECS) core .depend
+	/bin/rm -f *.o $(EXECS) core* .depend
 
 sg_dd: sg_dd.o sg_err.o llseek.o
 	$(LD) -o $@ $(LDFLAGS) $^
@@ -57,7 +57,7 @@
 	$(LD) -o $@ $(LDFLAGS) $^ -lpthread
 
 sgm_dd: sgm_dd.o sg_err.o llseek.o
-	$(LD) -o $@ $(LDFLAGS) $^ -lpthread
+	$(LD) -o $@ $(LDFLAGS) $^
 
 sg_map: sg_map.o sg_err.o
 	$(LD) -o $@ $(LDFLAGS) $^
@@ -69,9 +69,6 @@
 	$(LD) -o $@ $(LDFLAGS) $^
 
 sg_inq: sg_inq.o sg_err.o
-	$(LD) -o $@ $(LDFLAGS) $^
-
-scsi_devfs_scan: scsi_devfs_scan.o sg_err.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 sg_read: sg_read.o sg_err.o llseek.o
@@ -87,6 +84,18 @@
 	$(LD) -o $@ $(LDFLAGS) $^
 
 sg_senddiag: sg_senddiag.o sg_err.o
+	$(LD) -o $@ $(LDFLAGS) $^
+
+sg_opcodes: sg_opcodes.o sg_err.o
+	$(LD) -o $@ $(LDFLAGS) $^
+
+sg_persist: sg_persist.o sg_err.o
+	$(LD) -o $@ $(LDFLAGS) $^
+
+sg_write_long: sg_write_long.o sg_err.o
+	$(LD) -o $@ $(LDFLAGS) $^
+
+sg_read_long: sg_read_long.o sg_err.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 install: $(EXECS)

=== archive/Makefile ===
--- 
+++ 
@@ -6,15 +6,15 @@
 CC = gcc
 LD = gcc
 
-EXECS = sgq_dd sg_poll sg_bus_xfer sg_hold sg_debug isosize
+EXECS = sgq_dd sg_poll sg_bus_xfer sg_hold sg_debug isosize scsi_devfs_scan
 
 COMMON = isosize
 
 MAN_PGS = isosize.8
 MAN_PREF = man8
 
-CFLAGS = -g -O2 -Wall -D_REENTRANT
-# CFLAGS = -g -O2 -Wall -pedantic -D_REENTRANT
+CFLAGS = -g -O2 -W -Wall -D_REENTRANT
+# CFLAGS = -g -O2 -Wall -pedantic -std=c99 -D_REENTRANT
 
 LDFLAGS =
 
@@ -44,6 +44,9 @@
 isosize: isosize.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
+scsi_devfs_scan: scsi_devfs_scan.o ../sg_err.o
+	$(LD) -o $@ $(LDFLAGS) $^
+
 sg_debug: sg_debug.o
 	$(LD) -o $@ $(LDFLAGS) $^

=== examples/Makefile ===
--- 
+++ 
@@ -8,14 +8,17 @@
 LD = gcc
 
 EXECS = sg_simple1 sg_simple2 sg_simple3 sg_simple4 sg_simple16 \
-	sg_simple_aio sg_iovec_tst scsi_inquiry
+	sg_iovec_tst scsi_inquiry sg_excl sg_sense_test
+
+# EXECS = sg_simple1 sg_simple2 sg_simple3 sg_simple4 sg_simple16 \
+# 	  sg_simple_aio sg_iovec_tst scsi_inquiry sg_excl
 
 MAN_PGS = 
 MAN_PREF = man8
 
 LARGE_FILE_FLAGS = -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
 
-CFLAGS = -g -O2 -Wall -D_REENTRANT $(LARGE_FILE_FLAGS)
+CFLAGS = -g -O2 -W -Wall -D_REENTRANT $(LARGE_FILE_FLAGS)
 # CFLAGS = -g -O2 -Wall -D_REENTRANT -DSG_KERNEL_INCLUDES $(LARGE_FILE_FLAGS)
 # CFLAGS = -g -O2 -Wall -pedantic -D_REENTRANT $(LARGE_FILE_FLAGS)
 
@@ -54,6 +57,12 @@
 scsi_inquiry: scsi_inquiry.o
 	$(LD) -o $@ $(LDFLAGS) $^ 
 
+sg_excl: sg_excl.o ../sg_err.o
+	$(LD) -o $@ $(LDFLAGS) $^
+
+sg_sense_test: sg_sense_test.o ../sg_err.o
+	$(LD) -o $@ $(LDFLAGS) $^
+
 install: $(EXECS)
 	install -d $(INSTDIR)
 	for name in $^; \

## sg3-utils 1.17

=== Makefile ===
SHELL = /bin/sh

PREFIX=/usr/local
LIBDIR=$(DESTDIR)/$(PREFIX)/lib
INSTDIR=$(DESTDIR)/$(PREFIX)/bin
MANDIR=$(DESTDIR)/$(PREFIX)/share/man
INCLUDEDIR=$(DESTDIR)/$(PREFIX)/include

CC = gcc
LD = gcc

EXECS = sg_dd sgp_dd sgm_dd sg_read sg_map sg_scan sg_rbuf \
  	sginfo sg_readcap sg_turs sg_inq sg_test_rwbuf \
 	sg_start sg_reset sg_modes sg_logs sg_senddiag sg_opcodes \
 	sg_persist sg_write_long sg_read_long sg_requests sg_ses \
	sg_verify sg_emc_trespass sg_luns sg_sync sg_prevent \
	sg_get_config sg_wr_mode sg_rtpg sg_reassign sg_format \
	sg_rmsn sg_ident

MAN_PGS = sg_dd.8 sgp_dd.8 sgm_dd.8 sg_read.8 sg_map.8 sg_scan.8 sg_rbuf.8 \
	sginfo.8 sg_readcap.8 sg_turs.8 sg_inq.8 sg_test_rwbuf.8 \
	sg_start.8 sg_reset.8 sg_modes.8 sg_logs.8 sg_senddiag.8 \
	sg_opcodes.8 sg_persist.8 sg_write_long.8 sg_read_long.8 \
	sg_requests.8 sg_ses.8 sg_verify.8 sg_emc_trespass.8 \
	sg_luns.8 sg_sync.8 sg_prevent.8 sg_get_config.8 sg_wr_mode.8 \
	sg_rtpg.8 sg_reassign.8 sg_format.8 sg_rmsn.8 sg_ident.8
MAN_PREF = man8

HEADERS = sg_lib.h sg_cmds.h


LARGE_FILE_FLAGS = -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64

# CFLAGS = -O2 -Wall -W $(LARGE_FILE_FLAGS)
CFLAGS = -g -O2 -Wall -W $(LARGE_FILE_FLAGS)
# CFLAGS = -g -O2 -W -DSG_KERNEL_INCLUDES $(LARGE_FILE_FLAGS)
# CFLAGS = -g -O2 -Wall -W -pedantic -std=c99 $(LARGE_FILE_FLAGS)

CFLAGS_PTHREADS = -D_REENTRANT

LDFLAGS = 
# LDFLAGS = -v -lm

LIB_VINFO = 1:0:0
# Perhaps should use "-release RELEASE" instead
# RELEASE = 1.1

all: $(EXECS)

depend dep:
	for i in *.c; do $(CC) $(INCLUDES) $(CFLAGS) -M $$i; \
	done > .depend

clean:
	/bin/rm -f *.o $(EXECS) core* .depend *.a *.la *.lo
	/bin/rm -rf .libs


sg_lib.lo: sg_lib.o
	libtool --mode=compile $(CC) -c sg_lib.c

sg_cmds.lo: sg_cmds.o
	libtool --mode=compile $(CC) -c sg_cmds.c

libsgutils.la: sg_lib.lo sg_cmds.lo
	libtool --mode=link $(LD) -o libsgutils.la sg_lib.lo sg_cmds.lo \
	-rpath $(LIBDIR) -version-info $(LIB_VINFO)

# libsgutils.la: sg_lib.lo sg_cmds.lo
#	libtool --mode=link $(LD) -o libsgutils.la sg_lib.lo sg_cmds.lo \
#	-rpath $(LIBDIR) -release $(RELEASE)

sg_inq: sg_inq.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^ 

sg_dd: sg_dd.o llseek.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_scan: sg_scan.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^ 

sginfo: sginfo.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_start: sg_start.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^ 

sg_rbuf: sg_rbuf.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_readcap: sg_readcap.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sgp_dd.o: sgp_dd.c
	$(CC) $(INCLUDES) $(CFLAGS) $(CFLAGS_PTHREADS) -c $<

sgp_dd: sgp_dd.o llseek.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^ -lpthread

sgm_dd: sgm_dd.o llseek.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_map: sg_map.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_turs: sg_turs.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_test_rwbuf: sg_test_rwbuf.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_read: sg_read.o llseek.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_reset: sg_reset.o
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_modes: sg_modes.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_logs: sg_logs.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_senddiag: sg_senddiag.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_opcodes: sg_opcodes.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_persist: sg_persist.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_write_long: sg_write_long.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_read_long: sg_read_long.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_requests: sg_requests.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_ses: sg_ses.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_verify: sg_verify.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_emc_trespass: sg_emc_trespass.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_luns: sg_luns.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_sync: sg_sync.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_prevent: sg_prevent.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_get_config: sg_get_config.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_wr_mode: sg_wr_mode.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_rtpg: sg_rtpg.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_reassign: sg_reassign.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_format: sg_format.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_rmsn: sg_rmsn.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

sg_ident: sg_ident.o libsgutils.la
	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

install: $(EXECS)
	install -d $(INSTDIR)
	install -d $(LIBDIR)
	libtool --mode=install install -c libsgutils.la $(LIBDIR)/libsgutils.la
	for name in $^; \
	 do libtool --mode=install install -m 755 \
		$$name $(INSTDIR); \
	done
	install -d $(MANDIR)/$(MAN_PREF)
	for mp in $(MAN_PGS); \
	 do install -m 644 $$mp $(MANDIR)/$(MAN_PREF); \
	 gzip -9f $(MANDIR)/$(MAN_PREF)/$$mp; \
	done
	install -d $(INCLUDEDIR)/scsi
	for hdr in $(HEADERS); \
	 do install -m 644 $$hdr $(INCLUDEDIR)/scsi ; \
	done

uninstall:
	libtool --mode=uninstall rm -f $(LIBDIR)/libsgutils.la
	dists="$(EXECS)"; \
	for name in $$dists; do \
	 rm -f $(INSTDIR)/$$name; \
	done
	for mp in $(MAN_PGS); do \
	 rm -f $(MANDIR)/$(MAN_PREF)/$$mp.gz; \
	done
	for hdr in $(HEADERS); do \
	 rm -f $(INCLUDEDIR)/scsi/$$hdr ; \
	done

ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== archive/Makefile ===
--- 
+++ 
@@ -29,13 +29,13 @@
 clean:
 	/bin/rm -f *.o $(EXECS) core .depend
 
-sg_poll: sg_poll.o ../sg_err.o
+sg_poll: sg_poll.o ../sg_lib.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-sgq_dd: sgq_dd.o ../sg_err.o ../llseek.o
+sgq_dd: sgq_dd.o ../sg_lib.o ../llseek.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-sg_bus_xfer: sg_bus_xfer.o ../sg_err.o
+sg_bus_xfer: sg_bus_xfer.o ../sg_lib.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 sg_hold: sg_hold.o
@@ -44,7 +44,7 @@
 isosize: isosize.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-scsi_devfs_scan: scsi_devfs_scan.o ../sg_err.o
+scsi_devfs_scan: scsi_devfs_scan.o ../sg_lib.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 sg_debug: sg_debug.o

=== examples/Makefile ===
--- 
+++ 
@@ -33,34 +33,34 @@
 clean:
 	/bin/rm -f *.o $(EXECS) core .depend
 
-sg_simple1: sg_simple1.o ../sg_err.o
+sg_simple1: sg_simple1.o ../sg_lib.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 sg_simple2: sg_simple2.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-sg_simple3: sg_simple3.o ../sg_err.o
+sg_simple3: sg_simple3.o ../sg_lib.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-sg_simple4: sg_simple4.o ../sg_err.o
+sg_simple4: sg_simple4.o ../sg_lib.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-sg_simple16: sg_simple16.o ../sg_err.o
+sg_simple16: sg_simple16.o ../sg_lib.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-sg_simple_aio: sg_simple_aio.o ../sg_err.o
+sg_simple_aio: sg_simple_aio.o ../sg_lib.o
 	$(LD) -o $@ $(LDFLAGS) $^ -l aio
 
-sg_iovec_tst: sg_iovec_tst.o ../sg_err.o
+sg_iovec_tst: sg_iovec_tst.o ../sg_lib.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 scsi_inquiry: scsi_inquiry.o
 	$(LD) -o $@ $(LDFLAGS) $^ 
 
-sg_excl: sg_excl.o ../sg_err.o
+sg_excl: sg_excl.o ../sg_lib.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-sg_sense_test: sg_sense_test.o ../sg_err.o
+sg_sense_test: sg_sense_test.o ../sg_lib.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 install: $(EXECS)

=== utils/Makefile ===
--- 
+++ 
@@ -12,11 +12,8 @@
 MAN_PGS = 
 MAN_PREF = man8
 
-LARGE_FILE_FLAGS = -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
-
-CFLAGS = -g -O2 -Wall -D_REENTRANT $(LARGE_FILE_FLAGS)
-# CFLAGS = -g -O2 -Wall -D_REENTRANT -DSG_KERNEL_INCLUDES $(LARGE_FILE_FLAGS)
-# CFLAGS = -g -O2 -Wall -pedantic -D_REENTRANT $(LARGE_FILE_FLAGS)
+CFLAGS = -g -O2 -W 
+# CFLAGS = -g -O2 -W -pedantic -std=c99
 
 LDFLAGS =

## sg3-utils 1.21

=== Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
  	sg_persist sg_write_long sg_read_long sg_requests sg_ses \
 	sg_verify sg_emc_trespass sg_luns sg_sync sg_prevent \
 	sg_get_config sg_wr_mode sg_rtpg sg_reassign sg_format \
-	sg_rmsn sg_ident
+	sg_rmsn sg_ident sg_map26 sg_rdac sg_vpd
 
 MAN_PGS = sg_dd.8 sgp_dd.8 sgm_dd.8 sg_read.8 sg_map.8 sg_scan.8 sg_rbuf.8 \
 	sginfo.8 sg_readcap.8 sg_turs.8 sg_inq.8 sg_test_rwbuf.8 \
@@ -23,18 +23,19 @@
 	sg_opcodes.8 sg_persist.8 sg_write_long.8 sg_read_long.8 \
 	sg_requests.8 sg_ses.8 sg_verify.8 sg_emc_trespass.8 \
 	sg_luns.8 sg_sync.8 sg_prevent.8 sg_get_config.8 sg_wr_mode.8 \
-	sg_rtpg.8 sg_reassign.8 sg_format.8 sg_rmsn.8 sg_ident.8
+	sg_rtpg.8 sg_reassign.8 sg_format.8 sg_rmsn.8 sg_ident.8 \
+	sg_map26.8 sg_rdac.8 sg_vpd.8 sg3_utils.8
 MAN_PREF = man8
 
-HEADERS = sg_lib.h sg_cmds.h
-
-
+HEADERS = sg_lib.h sg_cmds.h sg_pt.h sg_io_linux.h sg_linux_inc.h
+
+OS_FLAGS = -DSG3_UTILS_LINUX
 LARGE_FILE_FLAGS = -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
-
-# CFLAGS = -O2 -Wall -W $(LARGE_FILE_FLAGS)
-CFLAGS = -g -O2 -Wall -W $(LARGE_FILE_FLAGS)
-# CFLAGS = -g -O2 -W -DSG_KERNEL_INCLUDES $(LARGE_FILE_FLAGS)
-# CFLAGS = -g -O2 -Wall -W -pedantic -std=c99 $(LARGE_FILE_FLAGS)
+S_CFLAGS = $(OS_FLAGS) $(LARGE_FILE_FLAGS)
+
+# CFLAGS = -O2 -Wall -W
+CFLAGS = -g -O2 -Wall -W
+# CFLAGS = -g -O2 -Wall -W -pedantic -std=c99
 
 CFLAGS_PTHREADS = -D_REENTRANT
 
@@ -48,7 +49,7 @@
 all: $(EXECS)
 
 depend dep:
-	for i in *.c; do $(CC) $(INCLUDES) $(CFLAGS) -M $$i; \
+	for i in *.c; do $(CC) $(INCLUDES) $(CFLAGS) $(S_CFLAGS) -M $$i; \
 	done > .depend
 
 clean:
@@ -56,15 +57,21 @@
 	/bin/rm -rf .libs
 
 
+.c.o:
+	$(CC) $(INCLUDES) $(CFLAGS) $(S_CFLAGS) -c -o $@ $<
+
 sg_lib.lo: sg_lib.o
 	libtool --mode=compile $(CC) -c sg_lib.c
 
 sg_cmds.lo: sg_cmds.o
 	libtool --mode=compile $(CC) -c sg_cmds.c
 
-libsgutils.la: sg_lib.lo sg_cmds.lo
+sg_pt_linux.lo: sg_pt_linux.o
+	libtool --mode=compile $(CC) -c sg_pt_linux.c
+
+libsgutils.la: sg_lib.lo sg_cmds.lo sg_pt_linux.lo
 	libtool --mode=link $(LD) -o libsgutils.la sg_lib.lo sg_cmds.lo \
-	-rpath $(LIBDIR) -version-info $(LIB_VINFO)
+	sg_pt_linux.lo -rpath $(LIBDIR) -version-info $(LIB_VINFO)
 
 # libsgutils.la: sg_lib.lo sg_cmds.lo
 #	libtool --mode=link $(LD) -o libsgutils.la sg_lib.lo sg_cmds.lo \
@@ -73,43 +80,44 @@
 sg_inq: sg_inq.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^ 
 
-sg_dd: sg_dd.o llseek.o libsgutils.la
-	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
-
-sg_scan: sg_scan.o libsgutils.la
+sg_dd: sg_dd.o llseek.o sg_io_linux.o libsgutils.la
+	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
+
+sg_scan: sg_scan.o sg_io_linux.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^ 
 
-sginfo: sginfo.o libsgutils.la
+sginfo: sginfo.o sg_io_linux.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
 
 sg_start: sg_start.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^ 
 
-sg_rbuf: sg_rbuf.o libsgutils.la
+sg_rbuf: sg_rbuf.o sg_io_linux.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
 
 sg_readcap: sg_readcap.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
 
 sgp_dd.o: sgp_dd.c
-	$(CC) $(INCLUDES) $(CFLAGS) $(CFLAGS_PTHREADS) -c $<
-
-sgp_dd: sgp_dd.o llseek.o libsgutils.la
+	$(CC) $(INCLUDES) $(CFLAGS) $(S_CFLAGS) $(CFLAGS_PTHREADS) \
+	-c -o sgp_dd.o $<
+
+sgp_dd: sgp_dd.o llseek.o sg_io_linux.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^ -lpthread
 
-sgm_dd: sgm_dd.o llseek.o libsgutils.la
-	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
-
-sg_map: sg_map.o libsgutils.la
+sgm_dd: sgm_dd.o llseek.o sg_io_linux.o libsgutils.la
+	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
+
+sg_map: sg_map.o sg_io_linux.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
 
 sg_turs: sg_turs.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
 
-sg_test_rwbuf: sg_test_rwbuf.o libsgutils.la
-	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
-
-sg_read: sg_read.o llseek.o libsgutils.la
+sg_test_rwbuf: sg_test_rwbuf.o sg_io_linux.o libsgutils.la
+	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
+
+sg_read: sg_read.o llseek.o sg_io_linux.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
 
 sg_reset: sg_reset.o
@@ -124,7 +132,7 @@
 sg_senddiag: sg_senddiag.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
 
-sg_opcodes: sg_opcodes.o libsgutils.la
+sg_opcodes: sg_opcodes.o sg_io_linux.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
 
 sg_persist: sg_persist.o libsgutils.la
@@ -177,11 +185,22 @@
 
 sg_ident: sg_ident.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
+
+sg_map26: sg_map26.o
+	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
+
+sg_rdac: sg_rdac.o libsgutils.la
+	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
+
+sg_vpd: sg_vpd.o sg_vpd_vendor.o libsgutils.la
+	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
+
 
 install: $(EXECS)
 	install -d $(INSTDIR)
 	install -d $(LIBDIR)
 	libtool --mode=install install -c libsgutils.la $(LIBDIR)/libsgutils.la
+	libtool --finish $(LIBDIR)
 	for name in $^; \
 	 do libtool --mode=install install -m 755 \
 		$$name $(INSTDIR); \

=== archive/Makefile ===
--- 
+++ 
@@ -29,13 +29,13 @@
 clean:
 	/bin/rm -f *.o $(EXECS) core .depend
 
-sg_poll: sg_poll.o ../sg_lib.o
+sg_poll: sg_poll.o ../sg_lib.o ../sg_io_linux.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-sgq_dd: sgq_dd.o ../sg_lib.o ../llseek.o
+sgq_dd: sgq_dd.o ../sg_lib.o ../sg_io_linux.o ../llseek.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-sg_bus_xfer: sg_bus_xfer.o ../sg_lib.o
+sg_bus_xfer: sg_bus_xfer.o ../sg_lib.o ../sg_io_linux.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 sg_hold: sg_hold.o
@@ -44,7 +44,7 @@
 isosize: isosize.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-scsi_devfs_scan: scsi_devfs_scan.o ../sg_lib.o
+scsi_devfs_scan: scsi_devfs_scan.o ../sg_lib.o ../sg_io_linux.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 sg_debug: sg_debug.o

=== examples/Makefile ===
--- 
+++ 
@@ -8,7 +8,8 @@
 LD = gcc
 
 EXECS = sg_simple1 sg_simple2 sg_simple3 sg_simple4 sg_simple16 \
-	sg_iovec_tst scsi_inquiry sg_excl sg_sense_test
+	sg_iovec_tst scsi_inquiry sg_excl sg_sense_test sg_simple5 \
+	sg_sat_identify sg_sat_chk_power sg_sat_smart_rd_data
 
 # EXECS = sg_simple1 sg_simple2 sg_simple3 sg_simple4 sg_simple16 \
 # 	  sg_simple_aio sg_iovec_tst scsi_inquiry sg_excl
@@ -33,34 +34,46 @@
 clean:
 	/bin/rm -f *.o $(EXECS) core .depend
 
-sg_simple1: sg_simple1.o ../sg_lib.o
+sg_simple1: sg_simple1.o ../sg_lib.o ../sg_io_linux.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 sg_simple2: sg_simple2.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-sg_simple3: sg_simple3.o ../sg_lib.o
+sg_simple3: sg_simple3.o ../sg_lib.o ../sg_io_linux.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-sg_simple4: sg_simple4.o ../sg_lib.o
+sg_simple4: sg_simple4.o ../sg_lib.o ../sg_io_linux.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-sg_simple16: sg_simple16.o ../sg_lib.o
+sg_simple16: sg_simple16.o ../sg_lib.o ../sg_io_linux.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-sg_simple_aio: sg_simple_aio.o ../sg_lib.o
+sg_simple_aio: sg_simple_aio.o ../sg_lib.o ../sg_io_linux.o
 	$(LD) -o $@ $(LDFLAGS) $^ -l aio
 
-sg_iovec_tst: sg_iovec_tst.o ../sg_lib.o
+sg_iovec_tst: sg_iovec_tst.o ../sg_lib.o ../sg_io_linux.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 scsi_inquiry: scsi_inquiry.o
 	$(LD) -o $@ $(LDFLAGS) $^ 
 
-sg_excl: sg_excl.o ../sg_lib.o
+sg_excl: sg_excl.o ../sg_lib.o ../sg_io_linux.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-sg_sense_test: sg_sense_test.o ../sg_lib.o
+sg_sense_test: sg_sense_test.o ../sg_lib.o ../sg_io_linux.o
+	$(LD) -o $@ $(LDFLAGS) $^
+
+sg_simple5: sg_simple5.o ../sg_lib.o ../sg_pt_linux.o
+	$(LD) -o $@ $(LDFLAGS) $^
+
+sg_sat_identify: sg_sat_identify.o ../sg_lib.o ../sg_io_linux.o
+	$(LD) -o $@ $(LDFLAGS) $^
+
+sg_sat_chk_power: sg_sat_chk_power.o ../sg_lib.o ../sg_io_linux.o
+	$(LD) -o $@ $(LDFLAGS) $^
+
+sg_sat_smart_rd_data: sg_sat_smart_rd_data.o ../sg_lib.o ../sg_io_linux.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 install: $(EXECS)

## sg3-utils 1.24

=== Makefile ===
--- 
+++ 
@@ -15,7 +15,8 @@
  	sg_persist sg_write_long sg_read_long sg_requests sg_ses \
 	sg_verify sg_emc_trespass sg_luns sg_sync sg_prevent \
 	sg_get_config sg_wr_mode sg_rtpg sg_reassign sg_format \
-	sg_rmsn sg_ident sg_map26 sg_rdac sg_vpd
+	sg_rmsn sg_ident sg_map26 sg_rdac sg_vpd sg_sat_identify \
+	sg_read_buffer sg_write_buffer sg_raw
 
 MAN_PGS = sg_dd.8 sgp_dd.8 sgm_dd.8 sg_read.8 sg_map.8 sg_scan.8 sg_rbuf.8 \
 	sginfo.8 sg_readcap.8 sg_turs.8 sg_inq.8 sg_test_rwbuf.8 \
@@ -24,10 +25,12 @@
 	sg_requests.8 sg_ses.8 sg_verify.8 sg_emc_trespass.8 \
 	sg_luns.8 sg_sync.8 sg_prevent.8 sg_get_config.8 sg_wr_mode.8 \
 	sg_rtpg.8 sg_reassign.8 sg_format.8 sg_rmsn.8 sg_ident.8 \
-	sg_map26.8 sg_rdac.8 sg_vpd.8 sg3_utils.8
+	sg_map26.8 sg_rdac.8 sg_vpd.8 sg3_utils.8 sg_sat_identify.8 \
+	sg_read_buffer.8 sg_write_buffer.8 sg_raw.8
 MAN_PREF = man8
 
-HEADERS = sg_lib.h sg_cmds.h sg_pt.h sg_io_linux.h sg_linux_inc.h
+HEADERS = sg_lib.h sg_cmds.h sg_cmds_basic.h sg_cmds_extra.h sg_pt.h \
+	sg_io_linux.h sg_linux_inc.h
 
 OS_FLAGS = -DSG3_UTILS_LINUX
 LARGE_FILE_FLAGS = -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
@@ -63,24 +66,28 @@
 sg_lib.lo: sg_lib.o
 	libtool --mode=compile $(CC) -c sg_lib.c
 
-sg_cmds.lo: sg_cmds.o
-	libtool --mode=compile $(CC) -c sg_cmds.c
+sg_cmds_basic.lo: sg_cmds_basic.o
+	libtool --mode=compile $(CC) -c sg_cmds_basic.c
+
+sg_cmds_extra.lo: sg_cmds_extra.o
+	libtool --mode=compile $(CC) -c sg_cmds_extra.c
 
 sg_pt_linux.lo: sg_pt_linux.o
 	libtool --mode=compile $(CC) -c sg_pt_linux.c
 
-libsgutils.la: sg_lib.lo sg_cmds.lo sg_pt_linux.lo
-	libtool --mode=link $(LD) -o libsgutils.la sg_lib.lo sg_cmds.lo \
-	sg_pt_linux.lo -rpath $(LIBDIR) -version-info $(LIB_VINFO)
-
-# libsgutils.la: sg_lib.lo sg_cmds.lo
-#	libtool --mode=link $(LD) -o libsgutils.la sg_lib.lo sg_cmds.lo \
-#	-rpath $(LIBDIR) -release $(RELEASE)
+libsgutils.la: sg_lib.lo sg_cmds_basic.lo sg_cmds_extra.lo sg_pt_linux.lo
+	libtool --mode=link $(LD) -o libsgutils.la sg_lib.lo sg_cmds_basic.lo \
+	sg_cmds_extra.lo sg_pt_linux.lo -rpath $(LIBDIR) \
+	-version-info $(LIB_VINFO)
+
+# libsgutils.la: sg_lib.lo sg_cmds_basic.lo sg_cmds_extra.lo
+#	libtool --mode=link $(LD) -o libsgutils.la sg_lib.lo sg_cmds_basic.lo \
+#	sg_cmds_extra.lo -rpath $(LIBDIR) -release $(RELEASE)
 
 sg_inq: sg_inq.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^ 
 
-sg_dd: sg_dd.o llseek.o sg_io_linux.o libsgutils.la
+sg_dd: sg_dd.o sg_io_linux.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
 
 sg_scan: sg_scan.o sg_io_linux.o libsgutils.la
@@ -102,10 +109,10 @@
 	$(CC) $(INCLUDES) $(CFLAGS) $(S_CFLAGS) $(CFLAGS_PTHREADS) \
 	-c -o sgp_dd.o $<
 
-sgp_dd: sgp_dd.o llseek.o sg_io_linux.o libsgutils.la
+sgp_dd: sgp_dd.o sg_io_linux.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^ -lpthread
 
-sgm_dd: sgm_dd.o llseek.o sg_io_linux.o libsgutils.la
+sgm_dd: sgm_dd.o sg_io_linux.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
 
 sg_map: sg_map.o sg_io_linux.o libsgutils.la
@@ -117,7 +124,7 @@
 sg_test_rwbuf: sg_test_rwbuf.o sg_io_linux.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
 
-sg_read: sg_read.o llseek.o sg_io_linux.o libsgutils.la
+sg_read: sg_read.o sg_io_linux.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
 
 sg_reset: sg_reset.o
@@ -132,7 +139,7 @@
 sg_senddiag: sg_senddiag.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
 
-sg_opcodes: sg_opcodes.o sg_io_linux.o libsgutils.la
+sg_opcodes: sg_opcodes.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
 
 sg_persist: sg_persist.o libsgutils.la
@@ -193,6 +200,18 @@
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
 
 sg_vpd: sg_vpd.o sg_vpd_vendor.o libsgutils.la
+	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
+
+sg_sat_identify: sg_sat_identify.o libsgutils.la
+	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
+
+sg_read_buffer: sg_read_buffer.o libsgutils.la
+	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
+
+sg_write_buffer: sg_write_buffer.o libsgutils.la
+	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^
+
+sg_raw: sg_raw.o libsgutils.la
 	libtool --mode=link $(LD) -o $@ $(LDFLAGS) $^

=== examples/Makefile ===
--- 
+++ 
@@ -9,7 +9,8 @@
 
 EXECS = sg_simple1 sg_simple2 sg_simple3 sg_simple4 sg_simple16 \
 	sg_iovec_tst scsi_inquiry sg_excl sg_sense_test sg_simple5 \
-	sg_sat_identify sg_sat_chk_power sg_sat_smart_rd_data
+	sg__sat_identify sg_sat_chk_power sg_sat_smart_rd_data \
+	sg_sat_set_features sg_sat_phy_event
 
 # EXECS = sg_simple1 sg_simple2 sg_simple3 sg_simple4 sg_simple16 \
 # 	  sg_simple_aio sg_iovec_tst scsi_inquiry sg_excl
@@ -67,13 +68,19 @@
 sg_simple5: sg_simple5.o ../sg_lib.o ../sg_pt_linux.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
-sg_sat_identify: sg_sat_identify.o ../sg_lib.o ../sg_io_linux.o
+sg__sat_identify: sg__sat_identify.o ../sg_lib.o ../sg_io_linux.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 sg_sat_chk_power: sg_sat_chk_power.o ../sg_lib.o ../sg_io_linux.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 sg_sat_smart_rd_data: sg_sat_smart_rd_data.o ../sg_lib.o ../sg_io_linux.o
+	$(LD) -o $@ $(LDFLAGS) $^
+
+sg_sat_set_features: sg_sat_set_features.o ../sg_lib.o ../sg_io_linux.o
+	$(LD) -o $@ $(LDFLAGS) $^
+
+sg_sat_phy_event: sg_sat_phy_event.o ../sg_lib.o ../sg_io_linux.o
 	$(LD) -o $@ $(LDFLAGS) $^
 
 install: $(EXECS)

=== utils/Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 CC = gcc
 LD = gcc
 
-EXECS = hxascdmp
+EXECS = hxascdmp sg_chk_asc
 
 MAN_PGS = 
 MAN_PREF = man8
@@ -27,6 +27,9 @@
 	/bin/rm -f *.o $(EXECS) core .depend
 
 hxascdmp: hxascdmp.o
+	$(LD) -o $@ $(LDFLAGS) $^
+
+sg_chk_asc: sg_chk_asc.o ../sg_lib.o
 	$(LD) -o $@ $(LDFLAGS) $^

## sg3-utils 1.29

=== debian/changelog ===
sg3-utils (1.29-1) unstable; urgency=low

  [Ritesh Raj Sarraf]
  * Adopt package as the new maintainer (Closes: #540828) 
  * New upstream release
    + Drop patches, merged upstream
      - 01_am_maintainer_mode.patch
      - 02_kfreebsd.patch
      - 99_autoreconf.patch
    + Add new patches
      - 001_man_page_fixes.patch
      - 002_spelling_error_fixes.patch
  * Update symbol list for new symbols introduced in this release 
  * Add ${misc:Depends} to make in lintian clean 
  * Add "source/format" and specify the current source format 
  * Update Standards Version to 3.8.4 (No changes required) 
  * Add Vcs headers 
  * Add DMUA Flag 
  * Explain about tarball re-packing in README.source

  [Jonathan McDowell]
  * Add myself to Uploaders.
  * Move to source format 3.0 (quilt).

 -- Jonathan McDowell <noodles@earth.li>  Wed, 21 Apr 2010 20:22:32 +0100

sg3-utils (1.28-2) unstable; urgency=low

  * QA upload.
  * Add libsgutils2-2.symbols.kfreebsd. Some of the symbols are Linux
    specific causing FTBFS on kfreebsd.

 -- Michael Biebl <biebl@debian.org>  Thu, 05 Nov 2009 20:42:13 +0100

sg3-utils (1.28-1) unstable; urgency=low

  * QA upload.
  * New upstream release.
    - Typo fixes in sg_ident.8 man page. (Closes: #525269)
    - README has been updated for new homepage URL. (Closes: #527904)
  * Add watch file to track new upstream releases.
  * Add symbols file for libsgutils2-2 for improved shlibs dependencies.
  * Cleanup debian/rules
    - Use DH_OPTIONS=-a for binary-arch so we don't have to add -a to each
      debhelper command.
    - Drop -V from dh_makeshlibs as we use a symbols file now.
    - Drop -l and -L parameter from dh_shlibdeps, no longer necessary.
    - Don't copy scripts/sas* as those scripts have been removed upstream.
    - Use dh_prep instead of previous dh_clean -k. (Closes: #541734)
  * Update debian/patches/02_kfreebsd.patch to apply cleanly.
  * Regenerate debian/patches/99_autoreconf.patch in an etch environment to
    keep the patch as small as possible.
  * Bump Standards-Version to 3.8.3. No further changes.
  * Update homepage URL in debian/copyright and add a Homepage: field to
    debian/control. (Closes: #545300)

 -- Michael Biebl <biebl@debian.org>  Mon, 26 Oct 2009 01:43:43 +0100

sg3-utils (1.27-1) unstable; urgency=low

  * QA upload.
    + Set maintainer to Debian QA Group <packages@qa.debian.org>
  * Don't ignore errors on make clean. 
  * Use quilt as a patch system.
  * Enable AM_MAINTAINER_MODE.
  * Add patch by Petr Salinger to fix FTBFS on GNU/kFreeBSD (closes: 
    #542748).

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 30 Aug 2009 17:35:35 +0200

sg3-utils (1.27-0.1) unstable; urgency=low

  [ Martin Pitt ]
  * Non-maintainer upload; this package blocks DeviceKit, and maintainer is
    apparently not active any more. Also clean up and modernize the package
    somewhat while we are at it.
  * New upstream release (required for current devicekit-disks).
    (Closes: #532546). Upstream original tarball repacked to not contain
    debian/ directory.
  * Rename libsgutils1{,-dev} to libsgutils2-2{,-dev}, upstream bumped SONAME.
    Also call the library libgsutils2-2 to match SONAME. Add
    Conflicts/Replaces for "libsgutils2" to provide a clean upgrade from the
    packages as provided by Upstream and Ubuntu.
  * debian/rules: Update build rules for upstream Makefile → autotools switch.
  * debian/rules: Fix cleaning a clean source package.
  * Demote Recommends to Suggests; the library doesn't actually call the
    binaries in sg3-utils. (Closes: #532547)
  * Drop debian/*.dirs, unnecessary with dh_install.
  * Drop sg3-utils.preinst, not necessary to deal with kernel 2.4 any more.
  * Drop libsgutils2-0.install, libsgutils2-0-dev.install, these packages
    don't exist.
  * Drop libsgutils2.post{inst,rm}: Basically empty, debhelper will create its
    own.
  * libsgutils2-dev.install: Drop *.lo.
  * debian/compat: 4 -> 7. Bump debhelper build-depends accordingly.
  * debian/control: Bump Standards-Version to 3.8.2.
  * debian/control: Modernize package description for Linux 2.6.
    (Closes: #506578)
  * debian/rules: Drop -k argument from dh_clean (thanks lintian).

  [ Frank Lichtenheld ]
  * debian/control, debian/rules: Add dependency of libsgutils-dev on
    libcam-dev on kfreebsd-*. (Closes: #519460)

 -- Martin Pitt <mpitt@debian.org>  Mon, 22 Jun 2009 12:04:20 +0200

sg3-utils (1.24-2) unstable; urgency=low

  * Cleaned up package description (Closes: #445920).
  * Don't make libtool think rpath is necessary (Closes: #451153)
  * Capitalized Linux in extended description (Closes: #457526).
  * Completed sentence in libsgutils1 long description (Closes: #421391).
  * Added patch from Aurelian Jarno to build on kfreebsd-* (Closes: #455430).
  * Symlinks in examples directory cleaned up (Closes: #372610).

 -- Eric Schwartz (Skif) <emschwar@debian.org>  Sun, 30 Dec 2007 11:52:58 -0700

sg3-utils (1.24-1) unstable; urgency=low

  * New upstream release
  * Conflicts with upstream libsgutils package libsgutils-1-0 (closes: #391077)

 -- Eric Schwartz (Skif) <emschwar@debian.org>  Tue,  5 Jun 2007 17:04:21 -0600

sg3-utils (1.21-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS due to old syscall usage (Closes: #395512).

 -- Luk Claes <luk@debian.org>  Sun,  5 Nov 2006 17:23:29 +0100

sg3-utils (1.21-2) unstable; urgency=low

  * Added Depends on libsgutils1 to libsgutils1-dev (closes: #387798)

 -- Eric Schwartz (Skif) <emschwar@debian.org>  Fri, 22 Sep 2006 00:20:28 -0600

sg3-utils (1.21-1) unstable; urgency=low

  * New upstream release

 -- Eric Schwartz (Skif) <emschwar@debian.org>  Wed, 13 Sep 2006 21:54:30 -0600

sg3-utils (1.20-1) unstable; urgency=low

  * New upstream release

 -- Eric Schwartz (Skif) <emschwar@debian.org>  Wed, 26 Apr 2006 22:31:15 -0600

sg3-utils (1.17-3) unstable; urgency=low

  * Cleaned up sg_read(8) manpage (Closes: #294521)



=== debian/control ===
Source: sg3-utils
Section: admin
Priority: optional
Maintainer: Ritesh Raj Sarraf <rrs@researchut.com>
Uploaders: Jonathan McDowell <noodles@earth.li>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>> 7), libtool, libcam-dev [kfreebsd-i386 kfreebsd-amd64]
Standards-Version: 3.8.4
Homepage: http://sg.danny.cz/sg/
Vcs-Git: git://git.debian.org/collab-maint/sg3-utils.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/sg3-utils.git

Package: sg3-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: sg-utils, cdwrite
Replaces: sg-utils
Description: utilities for devices using the SCSI command set
 Most OSes have SCSI pass-through interfaces that enable user space programs
 to send SCSI commands to a device and fetch the response. With SCSI to ATA
 Translation (SAT) many ATA disks now can process SCSI commands. Typically
 each utility in this package implements one SCSI command. See the draft
 standards at www.t10.org for SCSI command definitions plus SAT. ATA
 commands are defined in the draft standards at www.t13.org . For a mapping
 between supported SCSI and ATA commands and utility names in this package
 see the COVERAGE file.

Package: libsgutils2-2
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Architecture: any
Conflicts: libsgutils2
Replaces: libsgutils2
Suggests: sg3-utils
Description: utilities for devices using the SCSI command set (shared libraries)
 Most OSes have SCSI pass-through interfaces that enable user space programs
 to send SCSI commands to a device and fetch the response. With SCSI to ATA
 Translation (SAT) many ATA disks now can process SCSI commands. Typically
 each utility in this package implements one SCSI command. See the draft
 standards at www.t10.org for SCSI command definitions plus SAT. ATA
 commands are defined in the draft standards at www.t13.org . For a mapping
 between supported SCSI and ATA commands and utility names in this package
 see the COVERAGE file
 .
 Shared library used by the utilities in the sg3-utils package.

Package: libsgutils2-dev
Section: libdevel
Architecture: any
Depends: libsgutils2-2 (= ${binary:Version}), ${shlibs:Depends}, ${kfreebsd:Depends}, ${misc:Depends}
Conflicts: libsgutils1-dev
Suggests: sg3-utils
Description: utilities for devices using the SCSI command set (developer files)
 Most OSes have SCSI pass-through interfaces that enable user space programs
 to send SCSI commands to a device and fetch the response. With SCSI to ATA
 Translation (SAT) many ATA disks now can process SCSI commands. Typically
 each utility in this package implements one SCSI command. See the draft
 standards at www.t10.org for SCSI command definitions plus SAT. ATA
 commands are defined in the draft standards at www.t13.org . For a mapping
 between supported SCSI and ATA commands and utility names in this package
 see the COVERAGE file.
 .
 Developer files (i.e. headers and a static library) which are associated with
 the utilities in the sg3-utils package.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules file for the sg3-utils package

# This has to be exported to make some magic below work.
export DH_OPTIONS

# Uncomment this to turn on verbose mode. 
# export DH_VERBOSE=1

DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)

configure: configure-stamp
configure-stamp:
	dh_testdir
	CFLAGS="$(CFLAGS)" ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --bindir=/usr/bin --prefix=/usr --mandir=\$${prefix}/share/man
	touch configure-stamp

build: configure-stamp build-stamp
build-stamp:
	dh_testdir

	# Add here commands to compile the package.
	PREFIX=/usr MANDIR=/usr/share/man $(MAKE) -e

	touch build-stamp

clean:
	dh_testdir
	dh_testroot

	[ ! -f Makefile ] || $(MAKE) distclean

	rm -f build-stamp configure-stamp debian/substvars

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package into debian/tmp
	$(MAKE) -e install DESTDIR=$(CURDIR)/debian/tmp PREFIX=/usr

	dh_install --autodest --sourcedir=debian/tmp
	cp scripts/scsi* debian/sg3-utils/usr/bin

	dh_installman

# Build architecture-independent files here.
# Pass -i to all debhelper commands in this target to reduce clutter.
binary-indep: build install
# nothing to do here

# Build architecture-dependent files here.
binary-arch: DH_OPTIONS=-a
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installexamples
	dh_installmenu
	dh_installchangelogs ChangeLog
	dh_strip
	dh_link
	dh_compress -X archive -X .c -X .h
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
	echo kfreebsd:Depends=libcam-dev >>debian/libsgutils2-dev.substvars
endif
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## sg3-utils 1.30

=== debian/changelog ===
sg3-utils (1.30-1) unstable; urgency=low

  * New Upstream Release
  * Change address to my official Debian address and remove the DMUA flag 
  * Add a get-orig-source target 
  * Dropping patches that have merged upstream
    - 001_man_page_fixes.patch
    - 002_spelling_error_fixes.patch 
  * Update Standards Version to 3.9.1
    - Add BSD license to the copyright section 

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 11 Feb 2011 01:22:58 +0530
